// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services', 'starter.directives', 'ionicLazyLoad'])

.run(function($ionicPlatform, $rootScope) {
  AV.initialize('e4a8m7sjffy2wpes23q94kbb8pnx1bilus8hzvky9rn2ewxg', '935g7xdsgdfhc3nt24aeasspsngtygznwbhrw0gj1c0ueret');

  var cacheList = [
    "img/bg_inn.jpg",
    "img/bg_coffee.jpg",
    "img/bg_office.jpg"
  ];
  var cacheImages = [];
  angular.forEach(cacheList,function(value){
    var a = new Image();
    a.src = value;
    console.log(a.src);
    cacheImages.push(a);
  });

  $rootScope.getCacheSrc = function(target) {
    return cacheImages[target].src;
  };

  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      //StatusBar.styleDefault();
      //StatusBar.styleLightContent();
      //StatusBar.overlaysWebView(true);
      StatusBar.style(1) //Light
      //StatusBar.style(2) //Black, transulcent
      //StatusBar.style(3) //Black, opaque
    }
  });
})

.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider, $httpProvider) {

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js

  $ionicConfigProvider.backButton.previousTitleText(false).text('');
  $ionicConfigProvider.tabs.position('bottom'); // other values: top
  $httpProvider.defaults.useXDomain=true;
  $httpProvider.defaults.headers.common = 'Content-Type: application/json';
  delete $httpProvider.defaults.headers.common['X-Requested-With'];
  $ionicConfigProvider.views.forwardCache(true);

  $stateProvider


  .state('register', {
    url: '/register',
    templateUrl: 'templates/register.html',
    controller: 'RegisterCtrl'
  })

  .state('resetpassword', {
    url: '/resetpassword',
    templateUrl: 'templates/reset-password.html',
    controller: 'ResetPasswordCtrl'
  })

  // setup an abstract state for the tabs directive
  .state('tab', {
    url: '/tab',
    abstract: true,
    templateUrl: 'templates/tabs.html'
  })

  // Each tab has its own nav history stack:


  .state('tab.inn-cs', {
    url: '/inn/cs',
    views: {
      'tab-inn': {
        templateUrl: 'templates/inn-cs.html',
        controller: 'CustomerServiceCtrl'
      }
    }
  })

  .state('tab.coffee-cs', {
    url: '/coffee/cs',
    views: {
      'tab-coffee': {
        templateUrl: 'templates/coffee-cs.html',
        controller: 'CustomerServiceCtrl'
      }
    }
  })

  .state('tab.office-cs', {
    url: '/office/cs',
    views: {
      'tab-office': {
        templateUrl: 'templates/office-cs.html',
        controller: 'CustomerServiceCtrl'
      }
    }
  })

  .state('tab.rv-cs', {
    url: '/rv/cs',
    views: {
      'tab-rv': {
        templateUrl: 'templates/rv-cs.html',
        controller: 'CustomerServiceCtrl'
      }
    }
  })

  .state('tab.inn', {
    url: '/inn',
    views: {
      'tab-inn': {
        templateUrl: 'templates/tab-inn.html',
        controller: 'BoxInnCtrl'
      }
    }
  })

  .state('tab.inn-checkin', {
    url: '/inn/remote',
    views: {
      'tab-inn': {
        templateUrl: 'templates/inn-checkin.html',
        controller: 'BoxInnCheckInCtrl'
      }
    }
  })

  .state('tab.inn-remote', {
    url: '/inn/remote/:headId',
    views: {
      'tab-inn': {
        templateUrl: 'templates/inn-remote.html',
        controller: 'BoxInnRemoteCtrl'
      }
    }
  })

  .state('tab.inn-about', {
    url: '/inn/about',
    views: {
      'tab-inn': {
        templateUrl: 'templates/inn-about.html',
        controller: 'BoxInnAboutCtrl'
      }
    }
  })

  .state('tab.coffee', {
    url: '/coffee',
    views: {
      'tab-coffee': {
        templateUrl: 'templates/tab-coffee.html',
        controller: 'BoxCoffeeCtrl'
      }
    }
  })

  .state('tab.coffee-about', {
    url: '/coffee/about',
    views: {
      'tab-coffee': {
        templateUrl: 'templates/coffee-about.html',
        controller: 'BoxCoffeeAboutCtrl'
      }
    }
  })

  .state('tab.coffee-index', {
    url: '/coffee/index',
    views: {
      'tab-coffee': {
        templateUrl: 'templates/coffee-index.html',
        controller: 'BoxCoffeeIndexCtrl'
      }
    }
  })

  .state('tab.coffee-detail', {
    url: '/coffee/index/:objectId',
    views: {
      'tab-coffee': {
        templateUrl: 'templates/coffee-detail.html',
        controller: 'BoxCoffeeDetailCtrl'
      }
    }
  })

  .state('tab.office', {
    url: '/office',
    views: {
      'tab-office': {
        templateUrl: 'templates/tab-office.html',
        controller: 'BoxOfficeCtrl'
      }
    }
  })

  .state('tab.office-about', {
    url: '/office/about',
    views: {
      'tab-office': {
        templateUrl: 'templates/office-about.html',
        controller: 'BoxOfficeAboutCtrl'
      }
    }
  })
  .state('tab.rv', {
    url: '/rv',
    views: {
      'tab-rv': {
        templateUrl: 'templates/tab-rv.html',
        controller: 'BoxRvCtrl'
      }
    }
  })

  .state('tab.rv-about', {
    url: '/rv/about',
    views: {
      'tab-rv': {
        templateUrl: 'templates/rv-about.html',
        controller: 'BoxRvAboutCtrl'
      }
    }
  });

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/tab/inn');

});
