
angular.module('starter.directives', ['ionic'])
  .directive('dimmedShrink', function($document) {
    return {
      restrict: 'A',
      link: function($scope, $element, $attr) {
        var dimmedId = $attr.dimmedShrink;
        var starty = 120;
        var shrinkAmt;
        //var dimed = $document[0].body.querySelector('.boxinn-dimmed');
        var dimed = $document[0].getElementById(dimmedId);
        var dimedHeight = $document[0].body.querySelector('.boxinn-container').offsetHeight;
        var scrollTop = null
        $element.bind('scroll', function(e) {
          if(e.detail){
            scrollTop = e.detail.scrollTop;
          }else if(e.target){
            scrollTop = e.target.scrollTop;
          }
          if(scrollTop > starty){
            // Start shrinking
            shrinkAmt = dimedHeight - Math.max(0, (starty + dimedHeight) - scrollTop);

            var opacity = (scrollTop - 120) / 150;
            if (opacity>0.75) {
              opacity = 0.75;
            }
            ionic.requestAnimationFrame(function() {
              dimed.style.opacity = opacity;
            });
          } else {
            ionic.requestAnimationFrame(function() {
              dimed.style.opacity = 0;
            });
          }
        });
      }
    }
  })
  .directive('onValidSubmit', ['$parse', '$timeout', function($parse, $timeout) {
    return {
      require: '^form',
      restrict: 'A',
      link: function(scope, element, attrs, form) {
        form.$submitted = false;
        var fn = $parse(attrs.onValidSubmit);
        element.on('submit', function(event) {
          scope.$apply(function() {
            element.addClass('ng-submitted');
            form.$submitted = true;
            if (form.$valid) {
              if (typeof fn === 'function') {
                fn(scope, {$event: event});
              }
            }
          });
        });
      }
    }

  }])
  .directive('validated', ['$parse', function($parse) {
    return {
      restrict: 'AEC',
      require: '^form',
      link: function(scope, element, attrs, form) {
        var inputs = element.find("*");
        for(var i = 0; i < inputs.length; i++) {
          (function(input){
            var attributes = input.attributes;
            if (attributes.getNamedItem('ng-model') != void 0 && attributes.getNamedItem('name') != void 0) {
              var field = form[attributes.name.value];
              if (field != void 0) {
                scope.$watch(function() {
                  return form.$submitted + "_" + field.$valid;
                }, function() {
                  if (form.$submitted != true) return;
                  var inp = angular.element(input);
                  if (inp.hasClass('ng-invalid')) {
                    element.removeClass('has-success');
                    element.addClass('has-error');
                  } else {
                    element.removeClass('has-error').addClass('has-success');
                  }
                });
              }
            }
          })(inputs[i]);
        }
      }
    }
  }])
;
