angular.module('starter.services', [])

.service('UserService', function($window){
  var user = {};
  var userObject = AV.User.current();
  if(userObject) {
    user = userObject.attributes;
  }
  var service = {
    setUser: function (_object) {
      angular.merge(user, _object.attributes);
      userObject = _object;
    },
    get: function () {
      return user;
    },
    clear: function () {
      user = {};
    },
    current: function() {
      return AV.User.current()
    },
    signUp: function (_user, onsuccess, onerror) {
      var au = new AV.User();
      au.set("username", _user.username);
      au.set("password", _user.password);
      au.set("email", _user.email);
      au.set("name", _user.name);
      au.set("mobilePhoneNumber", _user.mobilePhoneNumber);
      au.signUp(null, {
        success: function (_user) {
          service.setUser(_user);
          return onsuccess(_user.attributes);
        },
        error: onerror
      });
    },
    signIn: function (username, password, onsuccess, onerror) {
      AV.User.logIn(username, password, {
        success: function (_user) {
          service.setUser(_user);
          return onsuccess(_user);
        },
        error: onerror
      });
    },
    signOut: function () {
      AV.User.logOut();
      service.clear();
    }
  }
  return service;
})

.service('PopupService', function($ionicPopup, $rootScope) {
  return {
    "alert":function(title,template,_option) {
      var option = {
        title:title,
        template:template,
        okText: '确定'
      };
      angular.merge(option,_option);
      return $ionicPopup.alert(option);
    },
    "confirm":function(title,template,_option){
      var option = {
        title: title,
        template: template,
        cancelText: '取消',
        okText: '确定'
      };
      angular.merge(option,_option);
      return $ionicPopup.confirm(option);
    }
  }
})

.service('CoffeeIndexes', function() {
  var coffees = [];
  return {
    "setArray":function(_coffee){
      coffees = _coffee;
    },
    "all":function(){
      return coffees;
    },
    "get":function(objectId){
      for(var i = 0; i < coffees.length; i++) {
        if(coffees[i].objectId == objectId) {
          return coffees[i]
        }
      }
      return null;
    }
  };
});

